=== debian/changelog ===
deepin-camera (6.0.2) unstable; urgency=medium

  * New version 6.0.2

 -- shuaijie <shuaijie@uniontech.com>  Fri, 10 March 2023 16:21:00 +0800

deepin-camera (6.0.1) unstable; urgency=medium

  * New version 6.0.1 

 -- muyuankai <muyuankai@uniontech.com>  Mon, 13 Jun 2022 10:40:00 +0800

deepin-camera (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Wed, 24 Feb 2016 14:15:54 +0800
